<?php
// $Id: convert_cache.php,v 1.0.0 2006/07/07 00:00:00 TK Exp $
//
// TK
//   http://hack.tv/
// Convert_Cache
//   http://puki.0hit.net/index.php/Convert_Cache/1.x/


// {{{ init

microtime_float('full');

define('CONVERT_CACHE_DIR',     DATA_HOME . 'convert_cache/');
define('CONVERT_CACHE_LIB_DIR', LIB_DIR   . 'convert_cache/');

define('CONVERT_CACHE_POST', ! empty($_POST));

require_once CONVERT_CACHE_LIB_DIR . 'convert_cache.ini.php';

convert_cache_read_all();

// }}} init
// {{{ class Convert_Cache

class Convert_Cache
{
	function getContents($filename)
	{
		$handle = fopen($filename, 'rb');
		if ($handle === false) {
			exit('Cache::getContents(' . $filename . ')');
		}
		flock($handle, LOCK_SH);

		$contents = '';
		while (! feof($handle)) {
			$contents .= fread($handle, 8192);
		}

		flock($handle, LOCK_UN);
		fclose($handle);

		return $contents;
	}

	function unserializeFile($filename)
	{
		return unserialize($this->getContents($filename));
	}

	function putContents($filename, $data)
	{
		$handle = fopen($filename, 'wb');
		if ($handle === false) {
			exit('Cache::putContents(' . $filename . ')');
		}
		flock($handle, LOCK_EX);

		$length = fwrite($handle, $data);

		flock($handle, LOCK_UN);
		fclose($handle);

		return $length;
	}

	function existFiles($filenames)
	{
		foreach ($filenames as $filename) {
			if (! file_exists($filename)) {
				return false;
			}
		}
		return true;
	}

	function getFileName($page, $dir, $ext = '')
	{
		static $encoded = array();

		if (! isset($encoded[$page])) {
			$encoded[$page] = encode_copy($page);
		}
		if ($ext != '') {
			$ext = '.' . $ext;
		}
		return CONVERT_CACHE_DIR . $dir . '/' . $encoded[$page] . $ext;
	}

	function makeConfigCache($names)
	{
		foreach ($names as $name) {
			$array = $this->getConfigArray($name);
			if (empty($array)) {
				$this->config = false;
				continue;
			}
			$filename = CONVERT_CACHE_DIR . $name . '.cfg';
			$this->putContents($filename, serialize($array));
		}
	}

	function getConfigArray($name)
	{
		static $config = null;

		if ($config === null) {
			$config = new Config('Convert_Cache');
		}
		if (! $config->read()) {
			$page = PKWK_CONFIG_PREFIX . 'Convert_Cache';
			exit('<p>404 config file (' . $page . ').</p>');
		}
		return $config->get($name);
	}

	function deleteAllCache()
	{
		foreach (array('', 'log', 'page') as $name) {
			if ($name == '') {
				$directry = CONVERT_CACHE_DIR;
			} else {
				$directry = CONVERT_CACHE_DIR . $name . '/';
			}
			$handle = opendir($directry);
			$array  = array('.htaccess', 'index.html');
			while (false !== ($filename = readdir($handle))) {
				if (! is_dir($directry . $filename) &&
				    ! in_array($filename, $array)) {
					unlink($directry . $filename);
				}
			}
			closedir($handle);
		}
	}
}

// }}} class Convert_Cache
// {{{ orig function

function microtime_float($id = 0)
{
	static $start = array();

	list($usec, $sec) = explode(' ', microtime());
	$float = ((float)$usec + (float)$sec);

	if (! isset($start[$id])) {
		$start[$id] = $float;
	} else {
		return sprintf('%01.03f', $float - $start[$id]);
	}
}

function convert_cache_read_all()
{
	if (CONVERT_CACHE_TYPE != 'all') {
		return;
	}
	microtime_float('read_all');
	require_once CONVERT_CACHE_LIB_DIR . 'class.read_all.php';
	$obj =& Convert_Cache_Read_All::getInstance();
	$obj->run();
}

function convert_cache_read_body($base)
{
	microtime_float('read_body');
	require_once CONVERT_CACHE_LIB_DIR . 'class.read_body.php';
	$obj =& new Convart_Cache_Read_Body();
	$obj->run($base);
	return $obj->getBody();
}

function convert_cache_delete($page)
{
	require_once CONVERT_CACHE_LIB_DIR . 'class.delete.php';
	$obj =& new Convert_Cache_Delete($page);
	$obj->run();
}

// }}} orig function
// {{{ copy function

function encode_copy($key)
{
	return ($key == '') ? '' : strtoupper(bin2hex($key));
}

// }}} copy function


// [EOF] 194