<?php
// $Id: class.delete.php,v 1.0.0 2006/07/07 00:00:00 TK Exp $


class Convert_Cache_Delete extends Convert_Cache
{
	var $page;

	var $key;


	function Convert_Cache_Delete($page)
	{
		$this->page = $page;
		$this->key  = 'Convert_Cache/' . CONVERT_CACHE_DELETE_KEY;
	}

	function run()
	{
		if ($this->isAllDeletion()) {
			$this->deleteAllCache();
		} else {
			$this->deleteUniqueCache();
			$this->deleteEveryCache();

			$this->deletePageCache($this->page);
			$this->deleteRefCache($this->page);
			$this->deleteRelCache($this->page);
			$this->deleteIncludeCache($this->page);
			$this->deleteDirectoryCache($this->page);
		}
	}

	function isAllDeletion()
	{
		if ($this->isMenuBar()) {
			return true;
		}
		if ($this->isKeyPage()) {
			return true;
		}
		return false;
	}

	function isMenuBar()
	{
		global $menubar;

		if ($this->page == $menubar) {
			return true;
		}
		$sub = substr($this->page, - (strlen($menubar) + 1));
		if ($sub == '/' . $menubar) {
			return true;
		}
		return false;
	}

	function isKeyPage()
	{
		return $this->page == PKWK_CONFIG_PREFIX . $this->key;
	}

	function deleteUniqueCache()
	{
		$filenames = array(
			CONVERT_CACHE_DIR . 'items',
		);
		if ($this->page == PKWK_CONFIG_PREFIX . 'Convert_Cache') {
			$filenames += array(
				CONVERT_CACHE_DIR . 'menu.cfg',
				CONVERT_CACHE_DIR . 'plugin.cfg',
			);
		}
		$this->deleteFiles($filenames);
	}

	function deleteEveryCache()
	{
		$filename = CONVERT_CACHE_DIR . 'log/every';
		if (file_exists($filename)) {
			$this->deleteCache($filename, true);
			unlink($filename);
		}
	}

	function deletePageCache($page)
	{
		$filenames = array(
				$this->getFileName($page, 'page'),
				$this->getFileName($page, 'log', 'no'),
			);
		$this->deleteFiles($filenames);
		$this->deleteLogCache($page);
	}

	function deleteLogCache($page)
	{
		$filename = $this->getFileName($page, 'log', 'log');
		if (file_exists($filename)) {
			foreach ($this->unserializeFile($filename) as $line) {
				list($_page, $_type) = explode(' => ', $line);
				$_filename = $this->getFileName($_page, 'log', $_type);
				if (! file_exists($_filename)) {
					continue;
				}
				$array = $this->unserializeFile($_filename);
				unset($array[$page]);
				if (empty($array)) {
					unlink($_filename);
				} else {
					$this->putContents($_filename, serialize($array));
				}
			}
			unlink($filename);
		}
	}

	function deleteRefCache($page)
	{
		$filename = CACHE_DIR . encode($page) . '.ref';
		if (file_exists($filename)) {
			$array = explode("\n", rtrim($this->getContents($filename)));
			foreach ($array as $line) {
				list($ref_page) = explode("\t", $line);
				$this->deletePageCache($ref_page);
			}
		}
	}

	function deleteRelCache($page)
	{
		$filename = CACHE_DIR . encode($page) . '.rel';
		if (file_exists($filename)) {
			$array = explode("\t", $this->getContents($filename));
			foreach ($array as $rel_page) {
				$this->deletePageCache($rel_page);
			}
		}
	}

	function deleteIncludeCache($page)
	{
		$this->deleteCache($this->getFileName($page, 'log', 'del'));
	}

	function deleteDirectoryCache($page)
	{
		foreach (explode('/', $page) as $path) {
			if (! isset($dir)) {
				$dir  = $path;
			} else {
				$dir .= '/' . $path;
			}
			$this->deleteCache($this->getFileName($dir, 'log', 'dir'));
		}
	}

	// $key : array(key => value)
	function deleteCache($filename, $key = true)
	{
		if (file_exists($filename)) {
			$array = $this->unserializeFile($filename);
			if ($key) {
				$array = array_keys($array);
			}
			foreach ($array as $_page) {
				$this->deletePageCache($_page);
			}
		}
	}

	function deleteFiles($filenames)
	{
		foreach ($filenames as $filename) {
			if (file_exists($filename)) {
				unlink($filename);
			}
		}
	}
}


// [EOF] 184