<?php
// $Id: class.items.php,v 1.0.0 2006/07/07 00:00:00 TK Exp $


class Convert_Cache_Item extends Convert_Cache
{
	var $page;


	function & getInstance()
	{
		static $instance = null;

		if ($instance === null) {
			$instance = new Convert_Cache_Item();
		}
		return $instance;
	}

	function setDefault($page)
	{
		$this->page = $page;
	}

	function make()
	{
		if ($this->canMake()) {
			$this->makeCache();
		}
	}

	function canMake()
	{
		if (! $this->isConfigCache()) {
			return false;
		}
		if (! defined('PLUGIN_DIR')) {
			$this->delAllCache();
			return false;
		}
		return true;
	}

	function isConfigCache()
	{
		return file_exists(CONVERT_CACHE_DIR . 'menu.cfg');
	}

	function makeCache()
	{
		$items = $this->unserializeFile(CONVERT_CACHE_DIR . 'menu.cfg');
		$array = array();
		foreach ($items as $item) {
			list($name, $args) = $item;
			$function = 'make' . ucfirst(strtolower($name));
			if (method_exists($this, $function)) {
				$array[$name] = $this->$function($args);
			}
		}
		$this->putContents(CONVERT_CACHE_DIR . 'items', serialize($array));
	}

	function makeRecent($args)
	{
		global $vars;

		require_once PLUGIN_DIR . 'recent.inc.php';

		$_vars['page'] = $vars['page'];
		$vars['page'] = '';
		$recent = do_plugin_convert('recent', $args);
		$vars['page'] = $_vars['page'];

		return $recent;
	}

	function makeTodays($args)
	{
	}

	function getCounter()
	{
		return 'counter.....';
	}
}


// [EOF] 88