<?php
// $Id: class.read_body.php,v 1.0.0 2006/07/08 00:00:00 TK Exp $


require_once CONVERT_CACHE_LIB_DIR . 'class.read.php';


class Convart_Cache_Read_Body extends Convert_Cache_Read
{
	var $page;

	var $mode;

	var $body;

	var $link;


	function run($base)
	{
		$this->setDefault($base);
		$this->setMode();
		$this->setBody();
	}

	function setDefault($base)
	{
		$this->page = $base;
		$this->mode = 'no';
		$this->body = '';
		$this->link = $this->getLink();
	}

	function setMode()
	{
		if ($this->canWork()) {
			if ($this->isPageCache($this->page)) {
				$this->mode = 'read';
			} elseif (CONVERT_CACHE_TYPE == 'all') {
			} elseif (! $this->isNoCache($this->page)) {
				$this->parse();
			}
		}
	}

	function setBody()
	{
		switch ($this->mode) {
			case 'read':
				$this->body = $this->readPageCache();
				break;

			case 'make':
				$this->body = $this->makePageCache();
				break;

			case 'no':
				$this->body = convert_html(get_source($this->page));
				break;

			default:
				exit('Convart_Cache_Read_Body::run()');
		}
	}

	function canWork()
	{
		if ($this->isMobile()) {
			return false;
		}
		if (CONVERT_CACHE_POST) {
			return false;
		}
		return true;
	}

	function isMobile()
	{
		return UA_PROFILE == 'keitai';
	}

	function readPageCache()
	{
		$filename = $this->getFileName($this->page, 'page');
		$array    = unserialize($this->getContents($filename));
		$this->GlobalZone($array);
		return $array['body'];
	}

	function makePageCache()
	{
		$array  = array('body' => convert_html(get_source($this->page)));
		$array += $this->GlobalZone();
		parent::makePageCache($array);
		return $array['body'];
	}

	function GlobalZone($array = null)
	{
		global $title, $head_tags, $foot_explain, $nofollow;

		if (is_array($array)) {
			foreach ($array as $key => $value) {
				if (CONVERT_CACHE_TYPE == 'all') {
					if ($key == 'notes') {
						$key   = 'foot_explain';
						$value = explode("\n", $value);
					} elseif ($key == 'head_tag') {
						$key   = 'head_tag';
						$value = explode("\n", $value);
					}
				}
				$$key = $value;
			}
		} else {
			$array = array(
				'title'        => $title,
				'head_tags'    => $head_tags,
				'foot_explain' => $foot_explain,
				'nofollow'     => $nofollow,
			);
			return $array;
		}
	}

	function getLink()
	{
		global $vars, $defaultpage;

		$link = '';
		if ($vars['page'] == $defaultpage) {
			$href  = ' href="http://hack.tv/"';
			$title = ' title="convert_cache"';
			$attribute = $href . $title;
			$link .= '<span class="convert_cache_link">';
			$link .= 'with <a' . $attribute . '>convert_cache</a>';
			$link .= '</span>';
		}
		return $link;
	}

	function getBody()
	{
		if (CONVERT_CACHE_STATUS_POSITION == 'top') {
			return $this->getStatus() . $this->body;
		} else {
			return $this->body . $this->getStatus();
		}
		
	}

	function getStatus()
	{
		$status  = '<!-- convert_cache -->';
		$status .= '<div class="convert_cache_status">' . "\n";
		$status .= '<p>';
		if (CONVERT_CACHE_STATUS) {
			$status .=  $this->mode;
			$status .= ' (' . $this->getTakeTime() . ') ';
		}
		$status .= $this->link;
		$status .= '</p>' . "\n";
		$status .= '</div>' . "\n";
		$status .= '<!-- /convert_cache -->';
		return $status;
	}

	function getTakeTime()
	{
		$array = $this->gettakeTimeArray();
		if (CONVERT_CACHE_STATUS_SIMPLE) {
			$taketime = $array['self'] . ' sec.';
		} else {
			$taketime = array();
			$taketime[] = '[self]' . $array['self'] . ' sec.';
			$taketime[] = '[full]' . $array['full'] . ' sec.';
			$taketime[] = '[norm]' . $array['norm'] . ' sec.';
			$taketime[] = '[hide]' . $array['hide'] . ' sec.';
			$taketime = implode(' | ', $taketime);
		}
		return $taketime;
	}

	function getTakeTimeArray()
	{
		$array = array(
			'self' => microtime_float('read_body'),
		);
		if (! CONVERT_CACHE_STATUS_SIMPLE) {
			$array += array(
				'full' => microtime_float('full'),
				'norm' => sprintf('%01.03f', getmicrotime() - MUTIME),
			);
			$array += array(
				'hide' => $array['full'] - $array['norm'],
			);
		}
		return $array;
	}
}


// [EOF] 203